﻿using System;
using System.IO;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;

namespace Microsoft.PowerShell.CmdletManagement
{
	public partial class ExtendedUserPermissionComboBox
	{
        public ExtendedUserPermissionComboBox()
		{
			this.InitializeComponent();			
		}
        public string Label
        {
            get { return (string)GetValue(LabelProperty); }
            set { SetValue(LabelProperty, value); }
        }

        public string SelectedValue
        {
            get { return (string)GetValue(SelectedValueProperty); }
            set { SetValue(SelectedValueProperty, value); }
        }

        public string HelpText
        {
            get { return (string)GetValue(HelpTextProperty); }
            set { SetValue(HelpTextProperty, value); }
        }
        
        public bool IsReadOnly
        {
            get { return true; }
            set { value = true; }
        }


        public static readonly DependencyProperty LabelProperty =
            DependencyProperty.Register("Label", typeof(string), typeof(ExtendedUserPermissionComboBox));
        public static readonly DependencyProperty PrimaryFieldProperty =
            DependencyProperty.Register("PrimaryField", typeof(string), typeof(ExtendedUserPermissionComboBox),
            new PropertyMetadata("Name"));
        public static readonly DependencyProperty HelpTextProperty =
            DependencyProperty.Register("HelpText", typeof(string), typeof(ExtendedUserPermissionComboBox));
        public static readonly DependencyProperty SelectedValueProperty =
            DependencyProperty.Register("SelectedValue", typeof(string), typeof(ExtendedUserPermissionComboBox));        
	}
}